diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/Sender2.java AndroidSource/frameworks/base/services/java/com/android/server/remote/Sender2.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/Sender2.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/Sender2.java	2016-02-18 10:38:19.000000000 +0900
@@ -0,0 +1,277 @@
+package com.android.server.remote;
+
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.InetAddress;
+import java.net.Socket;
+import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import android.content.Context;
+import android.graphics.Point;
+import android.location.Location;
+import android.service.devicemanager.Device;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.RemoteRequest;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.util.SparseArray;
+import android.view.Display;
+import android.view.MotionEvent;
+import android.view.WindowManager;
+
+public class Sender2 implements Runnable
+{
+	private static final String TAG = "RemoteService_Sender";
+    private static final int SERVERPORT = 55555;
+	
+    private ArrayList<String> connectedDevices;
+    private HashMap<String, AppendingObjectOutputStream> deviceToOutput;
+    
+    private SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutput;
+    
+    private int Xdefault;
+	private int Ydefault;
+	
+	public Sender2(Context context)
+	{
+		connectedDevices = new ArrayList<String>();
+		deviceToOutput = new HashMap<String, AppendingObjectOutputStream>();
+		resourceToOutput = new SparseArray<ArrayList<AppendingObjectOutputStream>>();
+		
+		WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+		Display display = wm.getDefaultDisplay();
+		Point size = new Point();
+		display.getSize(size);
+		
+		Xdefault = size.x;
+		Ydefault = size.y;
+	}
+	
+	// for resource request
+	public boolean connectToRemoteDevice(Device device)
+	{
+		try 
+		{
+			InetAddress deviceAddr;
+			Socket socketToDevice;
+			AppendingObjectOutputStream outToDevice;
+	    
+			deviceAddr = InetAddress.getByName(device.ipaddress);
+	        socketToDevice = new Socket(deviceAddr, SERVERPORT);
+	        socketToDevice.setTcpNoDelay(true);
+	        socketToDevice.setKeepAlive(true);
+	        socketToDevice.setSoTimeout(0);
+	        // serverIPs.add(serverAddr.getHostAddress());
+	        
+	        ObjectOutputStream out = new ObjectOutputStream(socketToDevice
+	                .getOutputStream());
+	        ObjectInputStream in = new ObjectInputStream(socketToDevice.getInputStream());
+	
+	        out.writeObject(device.askedResources);
+	        int[] responseFromServer = (int[])in.readObject();
+	
+	        if (responseFromServer.length > 0)
+	        {
+	            Log.d(TAG, "Successfully connected to: " + deviceAddr
+	            		+ "allowed: " + responseFromServer.toString());
+	            RemoteService.isConnectedToServer = true;
+	            outToDevice = new AppendingObjectOutputStream(socketToDevice.getOutputStream());
+	            
+	            connectedDevices.add(device.ipaddress);
+	            RemoteService.deviceToSocket.put(device.ipaddress, socketToDevice);
+	            deviceToOutput.put(device.ipaddress, outToDevice);
+	        }
+	        else
+	        	socketToDevice.close();
+        
+		} catch (UnknownHostException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (ClassNotFoundException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+		
+		return true;
+	}
+	
+	// for communication
+	public boolean connectToRemoteDevice(String deviceIP)
+	{
+		try 
+		{
+			InetAddress deviceAddr;
+			Socket socketToDevice;
+			AppendingObjectOutputStream outToDevice;
+	    
+			deviceAddr = InetAddress.getByName(deviceIP);
+	        socketToDevice = new Socket(deviceAddr, SERVERPORT);
+	        socketToDevice.setTcpNoDelay(true);
+	        socketToDevice.setKeepAlive(true);
+	        socketToDevice.setSoTimeout(0);
+	        // serverIPs.add(serverAddr.getHostAddress());
+	        
+	        ObjectOutputStream out = new ObjectOutputStream(socketToDevice
+	                .getOutputStream());
+	        ObjectInputStream in = new ObjectInputStream(socketToDevice.getInputStream());
+	
+	        out.writeObject("Hello");
+	        String responseFromServer = in.readObject().toString();
+	
+	        if (responseFromServer.equals("Gooooood"))
+	        {
+	            Log.d(TAG, "Successfully connected to: " + deviceAddr);
+	            RemoteService.isConnectedToServer = true;
+	            outToDevice = new AppendingObjectOutputStream(socketToDevice.getOutputStream());
+	            
+	            connectedDevices.add(deviceIP);
+	            RemoteService.deviceToSocket.put(deviceIP, socketToDevice);
+	            deviceToOutput.put(deviceIP, outToDevice);
+	        }
+	        else
+	        	socketToDevice.close();
+        
+		} catch (UnknownHostException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (IOException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        } catch (ClassNotFoundException e) {
+            // TODO Auto-generated catch block
+            e.printStackTrace();
+        }
+		
+		return true;
+	}
+	
+	public boolean connectToRemoteDevices(List<Device> devices)
+	{
+		for(Device device : devices)
+			connectToRemoteDevice(device);
+	        
+		return true;
+	}
+	
+	public boolean disconnectAllDevices()
+	{
+		try 
+		{
+			for(String device : connectedDevices)
+			{
+				RemoteService.deviceToSocket.get(device).close();
+				deviceToOutput.get(device).close();
+	        }
+			RemoteService.deviceToSocket.clear();
+			deviceToOutput.clear();
+		}
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		
+		return true;
+	}
+	
+	public boolean addRemoteDevice(ArrayList<Integer> resources, String deviceIP)
+	{
+		if(!RemoteService.deviceToSocket.containsKey(deviceIP))
+			connectToRemoteDevice(deviceIP);
+		
+		for(int resource : resources)
+		{
+			if(resourceToOutput.get(resource) == null)
+				resourceToOutput.put(resource, new ArrayList<AppendingObjectOutputStream>());  
+		
+			resourceToOutput.get(resource).add(deviceToOutput.get(deviceIP));
+		}
+		return true;
+	}
+	
+	public boolean sendRequest(RemoteRequest request)
+	{
+		
+        return true;
+	}
+	
+	public void sendMotionEvent(MotionEvent event)
+	{
+		float x = event.getX();
+		float y = event.getY();
+		
+		RemoteMotionEvent rme = new RemoteMotionEvent(event.getDownTime(),
+				event.getEventTime(), x / Xdefault, y / Ydefault,
+				event.getAction(), event.getSource());
+
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_TOUCH))
+				output.writeObject(rme);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendSensorEvent(RemoteSensorEvent rse)
+	{
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_SENSOR))
+				output.writeObject(rse);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendLocation(Location location)
+	{
+		// TODO Auto-generated method stub
+		RemoteLocation RL = new RemoteLocation(location);
+		
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_LOCATION))
+				output.writeObject(RL);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendMusicData(SdPackage MDtoSend)
+	{
+		try 
+		{
+			for (AppendingObjectOutputStream output : resourceToOutput.get(Device.RESOURCE_TYPE_AUDIO))
+				output.writeObject(MDtoSend);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+
+	@Override
+	public void run() 
+	{
+		// TODO Auto-generated method stub
+		
+	}
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/Sender.java AndroidSource/frameworks/base/services/java/com/android/server/remote/Sender.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/remote/Sender.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/remote/Sender.java	2016-09-26 17:16:10.571822749 +0900
@@ -0,0 +1,322 @@
+package com.android.server.remote;
+
+import java.io.IOException;
+import java.io.ObjectInputStream;
+import java.io.ObjectOutputStream;
+import java.net.InetAddress;
+import java.net.Socket;
+import java.net.UnknownHostException;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import android.content.Context;
+import android.graphics.Point;
+import android.location.Location;
+import android.os.Build;
+import android.provider.Settings.Secure;
+import android.service.devicemanager.Device;
+import android.service.remote.AppendingObjectOutputStream;
+import android.service.remote.RemoteRequest;
+import android.service.remote.SdPackage;
+import android.util.Log;
+import android.util.SparseArray;
+import android.view.Display;
+import android.view.MotionEvent;
+import android.view.WindowManager;
+
+public class Sender
+{
+	private static final String TAG = "RemoteService_Sender";
+    private static final int SERVERPORT = 55555;
+	
+    private int Xdefault;
+	private int Ydefault;
+	
+	/*private ArrayList<String> connectedDevices = RemoteService.connectedDevices;
+	private HashMap<String, Socket> deviceToSocket = RemoteService.deviceToSocket;
+	private HashMap<String, AppendingObjectOutputStream> deviceToOutput = RemoteService.deviceToOutput;
+    private SparseArray<ArrayList<AppendingObjectOutputStream>> resourceToOutput = RemoteService.resourceToOutput;*/
+    
+    private Thread connectionThread;
+    private Sender_ mSender;
+    
+    private String myName;
+	
+	public Sender(Context context)
+	{
+		WindowManager wm = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+		Display display = wm.getDefaultDisplay();
+		Point size = new Point();
+		display.getSize(size);
+		
+		Xdefault = size.x;
+		Ydefault = size.y;
+		
+		//myName = capitalize(Secure.getString(context.getContentResolver(),
+	    //            Secure.ANDROID_ID));
+		
+		myName = capitalize(Build.SERIAL); 
+	}
+	
+	// for resource request
+	public boolean connectToRemoteDevice(Device device)
+	{
+		mSender = new Sender_(myName, device.ipaddress, device.askedResources);
+		connectionThread = new Thread(mSender);
+		connectionThread.start();
+		
+		return true;
+	}
+	
+	// for communication
+	public boolean connectToRemoteDevice(String deviceIP)
+	{
+		mSender = new Sender_(myName, deviceIP);
+		connectionThread = new Thread(mSender);
+		connectionThread.start();
+		
+		return true;
+	}
+	
+	public boolean connectToRemoteDevices(List<Device> devices)
+	{
+		for(Device device : devices)
+			connectToRemoteDevice(device);
+	        
+		return true;
+	}
+	
+	public boolean disconnectAllDevices()
+	{
+		try 
+		{
+			for(String device : RemoteService.connectedDevices)
+			{
+				RemoteService.deviceToSocket.get(device).close();
+				RemoteService.deviceToOutput.get(device).close();
+	        }
+			RemoteService.deviceToSocket.clear();
+			RemoteService.deviceToOutput.clear();
+		}
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		
+		return true;
+	}
+	
+	public boolean addRemoteDevice(ArrayList<Integer> resourceTypes, String deviceIP)
+	{
+		if(!RemoteService.deviceToSocket.containsKey(deviceIP))
+		{
+			connectToRemoteDevice(deviceIP);
+			try {
+				connectionThread.join();
+			} catch (InterruptedException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+		
+		for(int resourceType : resourceTypes)
+		{
+			if(RemoteService.deviceToOutput.get(deviceIP) != null)
+				RemoteService.resourceToOutput.get(resourceType).add(RemoteService.deviceToOutput.get(deviceIP));
+			else
+				Log.d(TAG, resourceType + " is NULL!!!!!!!!");
+			
+		}
+		
+		return true;
+	}
+	
+	public boolean addRemoteDevice(int[] resourceTypes, String deviceIP)
+	{
+		if(!RemoteService.deviceToSocket.containsKey(deviceIP))
+		{
+			connectToRemoteDevice(deviceIP);
+			try {
+				connectionThread.join();
+			} catch (InterruptedException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+		
+		for(int resourceType : resourceTypes)
+		{
+			if(RemoteService.deviceToOutput.get(deviceIP) != null)
+				RemoteService.resourceToOutput.get(resourceType).add(RemoteService.deviceToOutput.get(deviceIP));
+			else
+				Log.d(TAG, resourceType + " is NULL!!!!!!!!");
+			
+		}
+		
+		return true;
+	}
+	
+	public boolean respondAllowedResources(String deviceIP, int[] resources)
+	{
+		if(RemoteService.deviceToOutput.get(deviceIP) != null)
+		{
+			try 
+			{
+				AppendingObjectOutputStream output = RemoteService.deviceToOutput.get(deviceIP);
+				output.writeObject(resources);
+			} catch (IOException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+			return true;
+		}
+		return false;
+	}
+	
+	public boolean sendRequestToEveryDevices(RemoteRequest request)
+	{
+		try 
+		{
+			for(String deviceIP : RemoteService.connectedDevices)
+				RemoteService.deviceToOutput.get(deviceIP).writeObject(request);
+			
+			
+		} catch (IOException e) {
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+		return true;
+    }
+	
+	public void sendVib(RemoteRequest request) throws IOException{
+	    
+	    for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_VIBRATOR))
+        {
+            if(output == null)
+                Log.d(TAG, "NULL!!!!!!!!");
+            else
+                output.writeObject(request);
+        }
+	}
+	
+	
+	public void sendMotionEvent(MotionEvent event)
+	{
+		//Log.d(TAG, "1: " + event.toString());
+		
+		float x = event.getX();
+		float y = event.getY();
+		
+		RemoteMotionEvent rme = new RemoteMotionEvent(event.getDownTime(),
+				event.getEventTime(), x / Xdefault, y / Ydefault,
+				event.getAction(), event.getSource());
+		
+		
+
+		try 
+		{
+			//Log.d(TAG, "2: " + RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_TOUCH).size());
+			
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_TOUCH))
+			{
+				if(output == null)
+					Log.d(TAG, "NULL!!!!!!!!");
+				else
+					output.writeObject(rme);
+			}
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendSensorEvent(RemoteSensorEvent rse)
+	{
+		try 
+		{
+			//Log.d(TAG, rse.toString());
+			
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_SENSOR))
+				output.writeObject(rse);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendLocation(Location location)
+	{
+		// TODO Auto-generated method stub
+		RemoteLocation RL = new RemoteLocation(location);
+		
+		try 
+		{
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_LOCATION))
+				output.writeObject(RL);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendMusicData(SdPackage MDtoSend)
+	{
+		try 
+		{
+			for (AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_AUDIO))
+				output.writeObject(MDtoSend);
+		} 
+		catch (IOException e) 
+		{
+			// TODO Auto-generated catch block
+			e.printStackTrace();
+		}
+	}
+	
+	public void sendVideoSignal(int vport){
+	    Log.d(TAG, "VideoSignal: " + vport);
+	    
+	    RemoteRequest request = new RemoteRequest();
+	    ArrayList<Object> vInfo = new ArrayList<Object>();
+	    vInfo.add(0, vport);
+	    vInfo.add(1, vport);
+	    request.set("video_streaming", "get_surface", vInfo);
+	    
+	    for(AppendingObjectOutputStream output : RemoteService.resourceToOutput.get(Device.RESOURCE_TYPE_VIDEO)){
+	        if(output == null){
+	            Log.d(TAG, "NULL!!!!!!");
+	        }
+	        else{
+	            try {
+                    output.writeObject(request);
+                } catch (IOException e) {
+                    // TODO Auto-generated catch block
+                    e.printStackTrace();
+                }
+	        }
+	        
+	        vport = vport + 2;
+	        vInfo.set(1, vport);
+	    }
+	}
+	
+	private String capitalize(String s) {
+        if (s == null || s.length() == 0) {
+            return "";
+        }
+        char first = s.charAt(0);
+        if (Character.isUpperCase(first)) {
+            return s;
+        } else {
+            return Character.toUpperCase(first) + s.substring(1);
+        }
+    }
+}
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/SystemServer.java AndroidSource/frameworks/base/services/java/com/android/server/SystemServer.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/SystemServer.java	2016-01-29 15:12:34.475488000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/SystemServer.java	2016-03-02 20:48:02.000000000 +0900
@@ -53,6 +53,7 @@
 import com.android.server.am.BatteryStatsService;
 import com.android.server.content.ContentService;
 import com.android.server.display.DisplayManagerService;
+import com.android.server.distribute.DistributedComputingService;
 import com.android.server.dreams.DreamManagerService;
 import com.android.server.input.InputManagerService;
 import com.android.server.media.MediaRouterService;
@@ -65,6 +66,8 @@
 import com.android.server.power.PowerManagerService;
 import com.android.server.power.ShutdownThread;
 import com.android.server.print.PrintManagerService;
+import com.android.server.devicemanager.DeviceManagementService;
+import com.android.server.remote.RemoteService;
 import com.android.server.search.SearchManagerService;
 import com.android.server.usb.UsbService;
 import com.android.server.wifi.WifiService;
@@ -157,6 +160,12 @@
         TelephonyRegistry telephonyRegistry = null;
         ConsumerIrService consumerIr = null;
 
+        // ADDED BY JH
+        RemoteService remoteService = null;
+        DeviceManagementService deviceService = null;
+        DistributedComputingService distributedcomputing = null;
+        // ADDED BY JH
+
         // Create a handler thread just for the window manager to enjoy.
         HandlerThread wmHandlerThread = new HandlerThread("WindowManager");
         wmHandlerThread.start();
@@ -289,6 +298,44 @@
             consumerIr = new ConsumerIrService(context);
             ServiceManager.addService(Context.CONSUMER_IR_SERVICE, consumerIr);
 
+            // ADDED BY JH
+            try
+			{
+				Slog.i(TAG, "Recommender Service");
+				deviceService = new DeviceManagementService(context);
+				ServiceManager.addService(Context.DEVICE_MANAGEMENT_SERVICE,
+						deviceService);
+			}
+			catch (Throwable e)
+			{
+				reportWtf("starting Recommender Service", e);
+			}
+            
+            try
+			{
+				Slog.i(TAG, "Remote Service");
+				remoteService = new RemoteService(context);
+				ServiceManager.addService(Context.REMOTE_SERVICE,
+						remoteService);
+			}
+			catch (Throwable e)
+			{
+				reportWtf("REMOTE REQUEST MANAGER FAILURE", e);
+			}
+            
+            try
+			{
+				Slog.i(TAG, "DistributedComputing Service");
+				distributedcomputing = new DistributedComputingService(context);
+				ServiceManager.addService(Context.DISTRIBUTED_COMPUTING_SERVICE,
+						distributedcomputing);
+			}
+			catch (Throwable e)
+			{
+				reportWtf("DISTRIBUTED COMPUTING FAILURE", e);
+			}
+			// ADDED BY JH
+            
             // only initialize the power service after we have started the
             // lights service, content providers and the battery service.
             power.init(context, lights, ActivityManagerService.self(), battery,
@@ -378,7 +425,7 @@
                 } catch (Throwable e) {
                     reportWtf("starting Accessibility Manager", e);
                 }
-            }
+		    }
         }
 
         try {
diff -urN Original_4.4.4_r1/frameworks/base/services/java/com/android/server/VibratorService.java AndroidSource/frameworks/base/services/java/com/android/server/VibratorService.java
--- Original_4.4.4_r1/frameworks/base/services/java/com/android/server/VibratorService.java	2016-01-29 15:12:34.479488000 +0900
+++ AndroidSource/frameworks/base/services/java/com/android/server/VibratorService.java	2016-02-16 20:22:55.000000000 +0900
@@ -16,6 +16,13 @@
 
 package com.android.server;
 
+import java.util.ArrayList;
+import java.util.LinkedList;
+import java.util.ListIterator;
+
+import com.android.internal.app.IAppOpsService;
+import com.android.internal.app.IBatteryStats;
+
 import android.app.AppOpsManager;
 import android.content.BroadcastReceiver;
 import android.content.Context;
@@ -25,13 +32,13 @@
 import android.database.ContentObserver;
 import android.hardware.input.InputManager;
 import android.os.BatteryStats;
+import android.os.Binder;
 import android.os.Handler;
+import android.os.IBinder;
 import android.os.IVibratorService;
 import android.os.PowerManager;
 import android.os.Process;
 import android.os.RemoteException;
-import android.os.IBinder;
-import android.os.Binder;
 import android.os.ServiceManager;
 import android.os.SystemClock;
 import android.os.UserHandle;
@@ -39,16 +46,10 @@
 import android.os.WorkSource;
 import android.provider.Settings;
 import android.provider.Settings.SettingNotFoundException;
+import android.util.Log;
 import android.util.Slog;
 import android.view.InputDevice;
 
-import com.android.internal.app.IAppOpsService;
-import com.android.internal.app.IBatteryStats;
-
-import java.util.ArrayList;
-import java.util.LinkedList;
-import java.util.ListIterator;
-
 public class VibratorService extends IVibratorService.Stub
         implements InputManager.InputDeviceListener {
     private static final String TAG = "VibratorService";
@@ -63,6 +64,8 @@
     private final IAppOpsService mAppOpsService;
     private final IBatteryStats mBatteryStatsService;
     private InputManager mIm;
+    
+
 
     volatile VibrateThread mThread;
 
@@ -152,6 +155,8 @@
         IntentFilter filter = new IntentFilter();
         filter.addAction(Intent.ACTION_SCREEN_OFF);
         context.registerReceiver(mIntentReceiver, filter);
+        
+
     }
 
     public void systemReady() {
@@ -192,7 +197,8 @@
     }
 
     public void vibrate(int uid, String packageName, long milliseconds, IBinder token) {
-        if (mContext.checkCallingOrSelfPermission(android.Manifest.permission.VIBRATE)
+        
+    	if (mContext.checkCallingOrSelfPermission(android.Manifest.permission.VIBRATE)
                 != PackageManager.PERMISSION_GRANTED) {
             throw new SecurityException("Requires VIBRATE permission");
         }
@@ -220,6 +226,8 @@
         } finally {
             Binder.restoreCallingIdentity(ident);
         }
+        
+
     }
 
     private boolean isAll0(long[] pattern) {
@@ -234,7 +242,7 @@
 
     public void vibratePattern(int uid, String packageName, long[] pattern, int repeat,
             IBinder token) {
-        if (mContext.checkCallingOrSelfPermission(android.Manifest.permission.VIBRATE)
+    	if (mContext.checkCallingOrSelfPermission(android.Manifest.permission.VIBRATE)
                 != PackageManager.PERMISSION_GRANTED) {
             throw new SecurityException("Requires VIBRATE permission");
         }
@@ -264,7 +272,9 @@
             } catch (RemoteException e) {
                 return;
             }
-
+            
+            Log.d("VibLatency", "VibVib");
+            
             synchronized (mVibrations) {
                 removeVibrationLocked(token);
                 doCancelVibrateLocked();
diff -urN Original_4.4.4_r1/frameworks/base/services/jni/Android.mk AndroidSource/frameworks/base/services/jni/Android.mk
--- Original_4.4.4_r1/frameworks/base/services/jni/Android.mk	2016-01-29 15:12:34.519488000 +0900
+++ AndroidSource/frameworks/base/services/jni/Android.mk	2015-01-12 10:39:51.000000000 +0900
@@ -18,6 +18,7 @@
     com_android_server_location_GpsLocationProvider.cpp \
     com_android_server_location_FlpHardwareProvider.cpp \
     com_android_server_connectivity_Vpn.cpp \
+    com_android_server_remote_RequestHandler.cpp \
     onload.cpp
 
 LOCAL_C_INCLUDES += \
diff -urN Original_4.4.4_r1/frameworks/base/services/jni/com_android_server_remote_RequestHandler.cpp AndroidSource/frameworks/base/services/jni/com_android_server_remote_RequestHandler.cpp
--- Original_4.4.4_r1/frameworks/base/services/jni/com_android_server_remote_RequestHandler.cpp	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/frameworks/base/services/jni/com_android_server_remote_RequestHandler.cpp	2016-09-23 16:53:07.473090667 +0900
@@ -0,0 +1,167 @@
+#define LOG_TAG "RemoteRequestJNI"
+
+#include "utils/Log.h"
+
+#include "jni.h"
+#include "JNIHelp.h"
+#include "android_os_MessageQueue.h"
+#include "android_runtime/AndroidRuntime.h"
+
+#include <gui/Sensor.h>
+#include <gui/SensorManager.h>
+#include <utils/Log.h>
+
+
+namespace android
+{
+
+//mutable sp<ISensorServer> mSensorServer;
+
+/*static void initSensorServer(JNIEnv *env, jobject clazz)
+{
+	const String16 name("sensorservice");
+	for (int i = 0; i < 4; i++) {
+		status_t err = getService(name, &mSensorServer);
+		if (err == NAME_NOT_FOUND) {
+			usleep(250000);
+			continue;
+		}
+		if (err != NO_ERROR) {
+			return err;
+		}
+	}
+}*/
+
+static jint nativeInitSensorEventQueue(JNIEnv *env, jclass clazz, jobject eventQ, jobject msgQ, jfloatArray scratch)
+{
+    /*SensorManager& mgr(SensorManager::getInstance());
+    sp<SensorEventQueue> queue(mgr.createEventQueue());
+
+    sp<MessageQueue> messageQueue = android_os_MessageQueue_getMessageQueue(env, msgQ);
+    if (messageQueue == NULL) {
+        jniThrowRuntimeException(env, "MessageQueue is not initialized.");
+        return 0;
+    }
+
+    sp<Receiver> receiver = new Receiver(queue, messageQueue, eventQ, scratch);
+    receiver->incStrong((void*)nativeInitSensorEventQueue);
+    return jint(receiver.get());*/
+	return 1;
+}
+
+static void sendRemoteEvent(JNIEnv *env, jobject clazz, jint type, jint sensor, jfloatArray data, jint status, jlong timestamp, jint sourcedevice)
+{
+    // ALOGI("vibratorOff\n");
+    //vibrator_off();
+	//ALOGD("sendTestEvent!!!!!!!");
+	//mSensorServer->sendTestEvent(NULL, NULL);
+
+	//ALOGD("sensor:%d, data:%f,%f,%f, timestamp:%lld", sensor, data[0], data[1], data[2], timestamp);
+
+	float* values = (float *)env->GetFloatArrayElements(data, 0);
+	int64_t time = (int64_t)timestamp;
+
+
+	//ADDED BY JH
+//	ALOGD("type:%d, sensor:%d, data:%8f,%8f,%8f, timestamp:%lld, sourceDevice:%d", type, sensor, values[0], values[1], values[2], time, sourcedevice);
+
+	SensorManager& mgr(SensorManager::getInstance());
+	//sp<SensorEventQueue> queue(mgr.createEventQueue());
+	mgr.sendRemoteEvent(type, sensor, values, status, time, sourcedevice);
+	/*Sensor const* const* sensorList;
+	size_t count = mgr.getSensorList(&sensorList);*/
+
+	//ALOGD("count=%d", count);
+
+
+
+	//JNIEnv* env = AndroidRuntime::getJNIEnv();
+
+	/*env->CallVoidMethod(mReceiverObject,
+						gBaseEventQueueClassInfo.dispatchSensorEvent,
+						sensor,
+						data,
+						status,
+						timestamp,
+						100);*/
+
+
+	if (env->ExceptionCheck()) {
+		ALOGE("Exception dispatching input event.");
+		//return 1;
+	}
+
+
+	env->ReleaseFloatArrayElements(data, values, 0);
+	//return 1;
+
+}
+
+static void setServerOn(JNIEnv *env, jobject clazz, jboolean flag)
+{
+	SensorManager& mgr(SensorManager::getInstance());
+	//sp<SensorEventQueue> queue(mgr.createEventQueue());
+	mgr.setServerOn((bool)flag);
+}
+
+static JNINativeMethod gRemoteServiceMethods[] = {
+    //{ "vibratorExists", "()Z", (void*)vibratorExists },
+    //{ "vibratorOn", "(J)V", (void*)vibratorOn },
+	{ "sendRemoteEvent", "(II[FIJI)V", (void*)sendRemoteEvent },
+    { "setServerOn", "(Z)V", (void*)setServerOn }
+};
+
+static JNINativeMethod gReceiverMethods[] = {
+    //{ "vibratorExists", "()Z", (void*)vibratorExists },
+    //{ "vibratorOn", "(J)V", (void*)vibratorOn },
+    { "sendRemoteEvent", "(II[FIJI)V", (void*)sendRemoteEvent }
+};
+
+static JNINativeMethod gSenderMethods[] = {
+    //{ "vibratorExists", "()Z", (void*)vibratorExists },
+    //{ "vibratorOn", "(J)V", (void*)vibratorOn },
+	{ "setServerOn", "(Z)V", (void*)setServerOn }
+};
+
+
+
+#define FIND_CLASS(var, className) \
+        var = env->FindClass(className); \
+        LOG_FATAL_IF(! var, "Unable to find class " className); \
+        var = jclass(env->NewGlobalRef(var));
+
+#define GET_METHOD_ID(var, clazz, methodName, methodDescriptor) \
+        var = env->GetMethodID(clazz, methodName, methodDescriptor); \
+        LOG_FATAL_IF(! var, "Unable to find method " methodName);
+
+int register_android_server_remote_RequestHandler(JNIEnv *env)
+{
+	jniRegisterNativeMethods(env, "com/android/server/remote/RemoteService",
+			gRemoteServiceMethods, NELEM(gRemoteServiceMethods));
+
+	jniRegisterNativeMethods(env, "com/android/server/remote/Receiver",
+			gReceiverMethods, NELEM(gReceiverMethods));
+
+	jniRegisterNativeMethods(env, "com/android/server/remote/Sender_",
+			gSenderMethods, NELEM(gSenderMethods));
+
+	/*jniRegisterNativeMethods(env, "android/hardware/SystemSensorManager",
+	        gSystemSensorManagerMethods, NELEM(gSystemSensorManagerMethods));*/
+
+	/*jniRegisterNativeMethods(env, "android/hardware/SystemSensorManager$BaseEventQueue",
+			gBaseEventQueueMethods, NELEM(gBaseEventQueueMethods));*/
+
+	/*FIND_CLASS(gBaseEventQueueClassInfo.clazz, "android/hardware/SystemSensorManager$BaseEventQueue");
+
+	GET_METHOD_ID(gBaseEventQueueClassInfo.dispatchSensorEvent,
+			gBaseEventQueueClassInfo.clazz,
+			"dispatchSensorEvent", "(I[FIJI)V");
+
+	GET_METHOD_ID(gBaseEventQueueClassInfo.dispatchFlushCompleteEvent,
+				  gBaseEventQueueClassInfo.clazz,
+				  "dispatchFlushCompleteEvent", "(I)V");*/
+
+	return 0;
+}
+};
+
diff -urN Original_4.4.4_r1/frameworks/base/services/jni/onload.cpp AndroidSource/frameworks/base/services/jni/onload.cpp
--- Original_4.4.4_r1/frameworks/base/services/jni/onload.cpp	2016-01-29 15:12:34.519488000 +0900
+++ AndroidSource/frameworks/base/services/jni/onload.cpp	2015-01-13 10:53:27.000000000 +0900
@@ -36,6 +36,7 @@
 int register_android_server_location_FlpHardwareProvider(JNIEnv* env);
 int register_android_server_connectivity_Vpn(JNIEnv* env);
 int register_android_server_AssetAtlasService(JNIEnv* env);
+int register_android_server_remote_RequestHandler(JNIEnv* env);
 };
 
 using namespace android;
@@ -67,6 +68,7 @@
     register_android_server_connectivity_Vpn(env);
     register_android_server_AssetAtlasService(env);
     register_android_server_ConsumerIrService(env);
+    register_android_server_remote_RequestHandler(env);
 
 
     return JNI_VERSION_1_4;
